// Adapted from https://github.com/kagis/pgwire/blob/0dc927f9f8990a903f238737326e53ba1c8d094f/mod.js#L2218
import * as pgwire from '@powersync/service-jpgwire';
import { toSyncRulesRow } from '@powersync/service-sync-rules';
/**
 * pgwire message -> SQLite row.
 * @param message
 */
export function constructAfterRecord(message) {
    const rawData = message.afterRaw;
    const record = pgwire.decodeTuple(message.relation, rawData);
    return toSyncRulesRow(record);
}
/**
 * pgwire message -> SQLite row.
 * @param message
 */
export function constructBeforeRecord(message) {
    const rawData = message.beforeRaw;
    if (rawData == null) {
        return undefined;
    }
    const record = pgwire.decodeTuple(message.relation, rawData);
    return toSyncRulesRow(record);
}
//# sourceMappingURL=pgwire_utils.js.map